/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: bipartite.h 9298 2009-09-02 23:10:56Z gawrilow $
*/

#ifndef _POLYMAKE_GRAPH_BIPARTITE_H
#define _POLYMAKE_GRAPH_BIPARTITE_H

#include <GenericGraph.h>
#include <vector>
#include <list>

namespace polymake { namespace graph {

   /* Determine whether an undirected graph is bipartite.
    * Returns a negative int if not bipartite. If the graph is bipartite,
    * the absolute difference of the black and white colored nodes is returned.
    *
    * @author Niko Witte
    */

   template <typename Graph>
   int bipartite_sign(const GenericGraph<Graph,Undirected>& G);

} }

#include <bipartite.tcc>

#endif // _POLYMAKE_GRAPH_BIPARTITE_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
