/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: diameter.tcc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <BFSiterator.h>
#include <diameter.h>

namespace polymake { namespace graph {

template <typename Graph>
int diameter(const GenericGraph<Graph>& G)
{
   BFSiterator<Graph, Visitor< NodeVisitor<int> > > it(G,0);
   int diam=0;
   for (typename Entire< Nodes<Graph> >::const_iterator n=entire(nodes(G)); !n.at_end(); ++n) {
      for (it.reset(*n); it.unvisited_nodes()>0; ++it) ;
      assign_max(diam, it.node_visitor()[it.last_unvisited()]);
   }
   return diam;
}

} }

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
