/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: altshuler_det.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <Rational.h>
#include <IncidenceMatrix.h>
#include <SparseMatrix.h>
#include <linalg.h>
#include <polymake.h>

namespace polymake { namespace graph {

Integer altshuler_det(const IncidenceMatrix<>& Inc)
{
   return Inc.rows() <= Inc.cols()
          ? det( same_element_sparse_matrix<Integer>(Inc) * T(same_element_sparse_matrix<Integer>(Inc)) )
          : det( T(same_element_sparse_matrix<Integer>(Inc)) * same_element_sparse_matrix<Integer>(Inc) );
}

Function4perl(&altshuler_det, "altshuler_det");

} }

