/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: metric2poly.cc 9514 2010-03-02 10:08:01Z sherrmann $
*/

#include <polymake.h>
#include <Matrix.h>
#include <ListMatrix.h>

namespace polymake { namespace polytope {

template <typename Scalar>
ListMatrix< Vector<Scalar> >  metric2poly(const Matrix<Scalar> &dist)
{
  const int d(dist.cols());
  
  ListMatrix< Vector<Scalar> > I = (zero_vector<Scalar>(d) | unit_matrix<Scalar>(d)); // non-negativity constraints
  for (int i=0; i<d; ++i)
    for (int j=i+1; j<d; ++j) {
      Vector<Scalar> ineq(d+1);
      ineq[0]=-dist(i,j); ineq[i+1]=ineq[j+1]=1;
      I /= ineq;
    }
  return I;
}

FunctionTemplate4perl("metric2poly(Matrix)");
} }
