/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: barycentric_subdivision.h 9298 2009-09-02 23:10:56Z gawrilow $
*/

#ifndef _POLYMAKE_BARYCENTRIC_SUBDIVISION_H
#define _POLYMAKE_BARYCENTRIC_SUBDIVISION_H

#include <HasseDiagram.h>
#include <Array.h>
#include <Set.h>
#include <Matrix.h>
#include <Rational.h>

#include <string>

namespace polymake { namespace topaz {

   // Computes the barycentric subdivision
   Array< Set<int> > bs(const HasseDiagram& HD);

   // Computes the VERTEX_LABELS
   Array<std::string> bs_labels(const HasseDiagram& HD);

   // Computes the GEOMETRIC_REALIZATION
   Matrix<Rational> bs_geom_real(const Matrix<Rational>& old_coord,
				 const HasseDiagram& HD);

} }


#endif // _POLYMAKE_BARYCENTRIC_SUBDIVISION_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
