/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: is_sphere_h.h 9298 2009-09-02 23:10:56Z gawrilow $
*/

#ifndef _POLYMAKE_IS_SPHERE_H_H
#define _POLYMAKE_IS_SPHERE_H_H

#include <BistellarComplex.h>

namespace polymake { namespace topaz {
  
  bool is_sphere_h(const HasseDiagram& HD, unsigned long seed, const int strategy, const int n_stable_rounds);

  template <typename Complex>
  bool is_sphere_h(const Complex& C, unsigned long seed, const int strategy, const int n_stable_rounds)
  {
     return is_sphere_h(pure_hasse_diagram(C), seed, strategy, n_stable_rounds);
  }

  bool is_ball_or_sphere_h(const HasseDiagram& HD, unsigned long seed, const int strategy, const int n_stable_rounds);

  template <typename Complex>
  bool is_ball_or_sphere_h(const Complex& C, unsigned long seed, const int strategy, const int n_stable_rounds)
  {
     return is_ball_or_sphere_h(pure_hasse_diagram(C), seed, strategy, n_stable_rounds);
  }

} }

#endif // _POLYMAKE_IS_SPHERE_H_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
