/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: facets_from_hasse_diagram.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <polymake.h>
#include <complex_tools.h>

namespace polymake { namespace topaz {
  
Array< Set<int> > facets_from_hasse_diagram(perl::Object p)
{
   const HasseDiagram HD(p);
   Array< Set<int> > F(select(HD.faces(), HD.in_adjacent_nodes(HD.top_node())));
   return F;
}

   Function4perl(&facets_from_hasse_diagram, "facets_from_hasse_diagram(FaceLattice)");
} }
