/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: is_ball_or_sphere.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <polymake.h>
#include <complex_tools.h>

namespace polymake { namespace topaz {
  
bool is_ball_or_sphere_client(perl::Object p)
{
   const Array< Set<int> > C = p.give("FACETS");
   const int d=p.give("DIM");
   const int n_vertices=p.give("N_VERTICES");

   switch (d) {
   case 0:
      return C.size()<3;
   case 1:
      return is_ball_or_sphere(C,n_vertices,int2type<1>());
   case 2:
      return is_ball_or_sphere(C,n_vertices,int2type<2>());
   default:
      throw std::runtime_error("is_ball_or_sphere: Dimension of the complex must be smaller than 3.");
   }

   // NOTREACHED
   return false;
}

   Function4perl(&is_ball_or_sphere_client, "is_ball_or_sphere(SimplicialComplex)");
} }


// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
