/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: simplex.cc 9560 2010-03-12 18:46:49Z smoeser $
*/

#include <polymake.h>
#include <Array.h>
#include <Set.h>

namespace polymake { namespace topaz {

perl::Object simplex(const int n)
{
   perl::Object p("SimplicialComplex");
   Array<Set<int> > facet(1);
   facet[0]=sequence(0,n+1);
   p.take("FACETS")<<facet;
   p.take("N_VERTICES")<<n+1;
   p.take("BALL")<<true;
   p.set_description()<<"Simplex of dimension "<<n<<"."<<endl;
   return p;

}


UserFunction4perl("# @category Producing from scratch"
		  "# A simplex of dimension //d//."
		  "# @param int d dimension"
		  "# @return SimplicialComplex",
		  &simplex, "simplex");
   
} }



// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
